/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package library;

import java.io.File;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.jtp.vlcfxmediaplayer.util.Video;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Text;

/**
 *
 * @author Dub
 */
public class LibraryDocBuilder {

    private final DocumentBuilder builder;
    private Document doc;
    //root node
    private Element root;
    //libItem node
    private Element libraryItem;
    private Element id;
    private Element mrl;
    private Element type;
    private Element extension;
    private Element thumbnail;
    //type nodes    
    private Element video;            
    private Element audio;
    //meta
    private Element metaData;
    private Element artist;
    private Element album;
    private Element albumArt;
    private Element title;
    private Element length;
    private Element trackNumber;
    private Element genre;
    
    

    public LibraryDocBuilder() throws ParserConfigurationException {
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        builder = factory.newDocumentBuilder();
    }

    public Document build(ArrayList<LibraryItem> items) {
        doc = builder.newDocument();
        doc.appendChild(createLibrary(items));
        return doc;
    }

    private Element createLibrary(ArrayList<LibraryItem> items) {        
        Element e = doc.createElement("library");
        
        return e;
    }
    
    private Element createLibraryItem(LibraryItem li){
        libraryItem = doc.createElement("libraryItem");
        
        return libraryItem;
    }

    private Element createVideo(Video v) {
        video = doc.createElement("video");
        
        return video;
    }
    
    private Element createAudio(LibraryItem li){
        audio = doc.createElement("audio");
        
        return audio;
    }

    private Element createTextElement(String name, String txt) {
        Text t = doc.createTextNode(txt);
        Element e = doc.createElement(name);
        e.appendChild(t);
        return e;
    }

    public void writeToFile(File f) {
        try {
            // write the content into xml file
            TransformerFactory transformerFactory = TransformerFactory.newInstance();
                      
            Transformer transformer = transformerFactory.newTransformer();
            transformer.setOutputProperty("{http://xml.apache.org/xslt}indent-amount", "4");
            transformer.setOutputProperty(OutputKeys.INDENT, "yes");            
            
            DOMSource source = new DOMSource(doc);
            StreamResult result = new StreamResult(f);

            // Output to console for testing
            //StreamResult result = new StreamResult(System.out);

            transformer.transform(source, result);

            System.out.println("File saved!");
            
        } catch (TransformerConfigurationException ex) {
            Logger.getLogger(LibraryDocBuilder.class.getName()).log(Level.SEVERE, null, ex);
        } catch (TransformerException ex) {
            Logger.getLogger(LibraryDocBuilder.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}
