/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package library;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;
import org.w3c.dom.Document;
import org.xml.sax.SAXException;

/**
 *
 * @author Dub
 */
public class LibraryDocParser {
    private final DocumentBuilder builder;
    private final XPath path;
    
    public LibraryDocParser() throws ParserConfigurationException{
        DocumentBuilderFactory dbfact = DocumentBuilderFactory.newInstance();
        builder = dbfact.newDocumentBuilder();
        XPathFactory xpfact = XPathFactory.newInstance();
        path = xpfact.newXPath();
    }
    
    public ArrayList<LibraryItem> parse(File f) throws SAXException, IOException, XPathExpressionException{
        Document doc = builder.parse(f);
        
        ArrayList<LibraryItem> items = new ArrayList<>();
        int itemCount = Integer.parseInt(path.evaluate("count(/library/libraryItem)", doc));
        for(int i = 1; i <= itemCount; i++){
            String file = path.evaluate("/library/libraryItem["+i+"]/mrl", doc);
                        
            items.add(new LibraryItem(new File(file)));
        }
        
        return items;
    }
}
