/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.jtp.vlcfxmediaplayer.components;

import library.Library;
import java.io.IOException;
import java.net.URL;
import java.util.ResourceBundle;
import java.util.logging.Level;
import java.util.logging.Logger;
import javafx.beans.InvalidationListener;
import javafx.beans.Observable;
import javafx.collections.FXCollections;
import javafx.event.EventHandler;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Node;
import javafx.scene.Scene;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.AnchorPane;
import javafx.scene.layout.StackPane;
import javafx.scene.layout.TilePane;
import javafx.stage.Stage;

/**
 * FXML Controller class
 *
 * @author Dub
 */
public class LibraryViewer extends AnchorPane implements Initializable {
    private Stage stage;
    private Scene scene;
    private Library library;
    
    @FXML
    private AnchorPane AnchorPane;
    @FXML
    private StackPane contentPane;
    @FXML
    private StackPane header;
    @FXML 
    private TilePane tilePane;
    @FXML 
    private StackPane searchHolder;
    
    private SearchBox searchBox;
    
    public LibraryViewer(){
        this.library = new Library();  
        FXMLLoader loader = new FXMLLoader(getClass().getResource("/fxml/controls/LibraryViewer.fxml"));
        loader.setRoot(this);
        loader.setController(this);
        try {
            loader.load();
        } catch (IOException ex) {
            Logger.getLogger(LibraryViewer.class.getName()).log(Level.SEVERE, null, ex);
        }
        scene = new Scene(this);
        stage = new Stage();
        stage.setScene(scene);
        stage.show();
    }

    /**
     * Initializes the controller class.
     */
    @Override
    public void initialize(URL url, ResourceBundle rb) {
        // TODO
        searchBox = new SearchBox(FXCollections.observableArrayList(library.getVideos()));
        searchBox.getResultsLoadedProperty().addListener(new InvalidationListener() {
            @Override
            public void invalidated(Observable o) {
                tilePane.getChildren().clear();
                tilePane.getChildren().addAll(searchBox.getNewList());
            }
        });
        searchHolder.getChildren().add(searchBox);
        
        
        
        tilePane.setHgap(5d);
        tilePane.setVgap(5d);
        tilePane.setPrefColumns(4);
        tilePane.getChildren().addAll(library.getVideos());
        for(final Node v : tilePane.getChildren()){
            v.setOnMouseEntered(new EventHandler<MouseEvent>() {

                @Override
                public void handle(MouseEvent t) {
                    v.toFront();                    
                    v.setScaleX(1.5);
                    v.setScaleY(1.5);
                }
            });
            v.setOnMouseExited(new EventHandler<MouseEvent>() {

                @Override
                public void handle(MouseEvent t) {
                    v.setScaleX(1);
                    v.setScaleY(1);
                }
            });
        }
       
    }    
}
